package contapalavras;

import java.io.PrintStream;
import java.io.Reader;
import java.util.Scanner;

public class ContaPalavras {

    Contagem contagem;

    public ContaPalavras(Contagem contagem) {
        this.contagem = contagem;
    }

    void adicionaPalavras(Reader reader) {
        Scanner scanner = new Scanner(reader);
        scanner.useDelimiter("[^\\p{IsLetter}]+");
        while (scanner.hasNext()) {
            contagem.adiciona(scanner.next());
        }
    }

    void exibeMaisFrequentes(PrintStream stream, int quantidade) {
        for (String palavra : contagem.getMaisFrequentes(quantidade)) {
            stream.println(palavra + " " + contagem.getFrequencia(palavra));
        }
    }

}
